<template>
  <main>
    <div class="container mx-auto flex justify-center">
      <div class="flex col-12">
        <div class="left col-3 p-2">
          <div class="flex flex-column">
            <Button class="mb-2 p-button-xs" @click="onLogin('Instagram')">Login to Instagram</Button>

            <Button
              class="mb-2 p-button-xs"
              @click="onLogin('Facebook Creator Studio')"
            >Login to Facebook Creator Studio</Button>

            <div class="my-2"></div>

            <p class="font-sans mb-2">Start Date:</p>
            <Calendar :inline="true" class="p-0 mb-2" v-model="date" />

            <div class="my-2"></div>

            <p class="font-sans mb-2">Hours to post:</p>

            <div class="flex justify-between">
              <div class="col-6 p-0 pr-1">
                <Button
                  @click="addHour"
                  class="mb-2 w-full inline-block text-center p-button-outlined"
                >Add Hour</Button>
              </div>

              <div class="col-6 p-0 pl-1">
                <Button
                  @click="removeHour"
                  class="mb-2 w-full inline-block text-center p-button-outlined"
                >Remove Hour</Button>
              </div>
            </div>

            <div>
              <TimePicker
                v-for="(_, index) in hoursToPost"
                @change="onTimeChange($event, index)"
                class="mb-2"
              />
            </div>

            <div class="field-checkbox mt-2">
              <Checkbox id="credit-autor" v-model="creditAuthor" :binary="true" />
              <label class="font-sans" for="credit-autor">Credit author in caption?</label>
            </div>

            <div class="field-checkbox mt-2">
              <Checkbox id="force-hashtags" v-model="forceHashtags" :binary="true" />
              <label class="font-sans" for="force-hashtags">Use only your hashtags?</label>
              <div
                :style="{ width: '20px', height: '20px' }"
                v-tooltip="'When checked, any hashtags from the origin post will be omiited and only the hashtags provided here will be taken. If not checked the hashtags will be merged unitl a total of 30.'"
                class="bg-gray-600 text-xs text-white p-2 rounded-full text flex align-items-center justify-content-center ml-auto"
              >
                <i :style="{ fontSize: '0.625rem' }" class="pi pi-info"></i>
              </div>
            </div>

            <Button @click="onRepost" class="mb-2 inline-block text-centeru">Repost</Button>
          </div>
        </div>
        <div class="flex-grow col-5 right p-0">
          <div class="p-2">
            <TextArea
              v-model="urls"
              :placeholder="placeholder"
              :style="{ height: '250px' }"
              class="w-full"
            />
            <TextArea
              v-model="hashtags"
              placeholder="#hashtags #to #add #separed #by #whitespace"
              :style="{ height: '250px' }"
              class="w-full"
            />
          </div>
        </div>
        <div class="col-4 p-0 right">
          <div class="p-2">
            <div
              class="p-2 border overflow-auto border-solid border-gray-200 rounded-lg"
              :style="{ height: '500px' }"
            >
              <div v-for="log in logs" class="font-mono w-full text-slate-600">
                <div class="text-green-700 font-bold">{{ log.date }}</div>
                <div>{{ log.value }}</div>
              </div>
            </div>
          </div>
          <div class="p-2">
            <Button class="p-button-outlined">Clear</Button>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script setup>
import { ref } from 'vue'

import { loginToInstagram, loginToCreatorStudio, post } from './services/api'

import TimePicker from './components/TimePicker.vue'

const placeholder = `https://www.instagram.com/p/CZ7WbwwKEGX/
https://www.instagram.com/p/CZ7La61olVp/
...
`

// Dates
const date = ref(new Date())
const hoursToPost = ref(['12:00 AM'])

function onTimeChange(value, index) {
  hoursToPost.value[index] = value
}

function addHour() {
  hoursToPost.value.push('12:00 AM')
}

function removeHour() {
  hoursToPost.value.pop()
}

// Logs
const logs = ref([])

function addLog(value) {
  const date = new Date()

  logs.value.push({
    date: date.toLocaleString(),
    value,
  })
}

addLog(`Welcome to the Instagram repost and schedule application!
First Login to Instagram and then to Facebook Creator Studio.
Paste Instagram links in the left text area and click repost.
`)

// Login
async function onLogin(type) {
  let data = { message: '' }
  logs.value.push(`${type} login`)
  addLog(`${type} login`)

  switch (type) {
    case 'Instagram':
      data = await loginToInstagram()
      break
    case 'Facebook Creator Studio':
      data = await loginToCreatorStudio()
      break
  }

  if (data.error) {
    addLog(data.error)
  }
}

const hashtags = ref('')
const forceHashtags = ref(false)
const creditAuthor = ref(false)
// Repost
const urls = ref('')

async function onRepost() {
  const data = parseData({
    date: date.value,
    hours: hoursToPost.value,
    urls: urls.value,
    hashtags: hashtags.value,
  })

  addLog("Posting...")

  if (data.codes.length === 0) {
    addLog("ERROR: No codes found! Fix the URLs and try again.")
    return
  }

  if (data.hours.length === 0) {
    addLog("ERROR: Select hours to post!")
    return
  }

  const result = await post(data)
  console.error(result)
}

function parseData({ date, hours, urls, hashtags }) {
  const codes = urls.split('\n').filter(Boolean).map(url => {
    const [, id] = url.match(/\/p\/([^/]+)/)

    return id
  })

  return {
    date: date.toLocaleDateString(),
    hours: hours,
    codes,
    hashtags: hashtags.trim().split(' ').filter(Boolean),
    forceHashtags: forceHashtags.value,
    creditAuthor: creditAuthor.value
  }
}
</script>

<style>
</style>